## ASR-LLM-TTS

This project implements end-to-end voice dialogue function. The ASR model detects speech and converts it into text. The text is given to the LLM model to output the dialogue text, and then the text is given to the TTS model to output the dialogue voice.

The ASR used in this project is sensevoice, the LLM uses qwen2.5:0.5b, and the TTS uses melotts.

## Usage

Please make sure the device firmware is no less than 2.2rc2 Firmware download address: https://archive.spacemit.com/image/k1/version/bianbu

```bash
sudo apt update
sudo apt install ASR-LLM-TTS
```

After installing the Deb package, you need to restart the computer to use the service. After installing the Deb source code, it is located in the `/usr/share/asr-llm-tts` directory.
After restarting the computer, enter:

```bash
tts
```

The three modules of this project are made into services, namely the main program, web configuration service and message queue service.

### Web configuration service

Open the browser and enter `http://localhost:5000` to configure the services of different backends such as ASR, LLM and TTS(Currently ASR only supports SenseVoice, LLM only supports ollama, and TTS only supports MeloTTS).

### Main program service

This service is the core of the code and integrates three modules: ASR, LLM, and TTS. ASR converts speech into text, which is then transferred to the large language model for inference. The inference result is then transferred to the TTS model for speech generation, and finally played through the playback function.

### Messagebus service

This service does not require any configuration. It is a message bus that communicates the recording function with the main program so that the recording after the terminal input `tts` can be smoothly transmitted to the ASR-LLM-TTS program for conversation.

The three services are demo_serve.serveice, messagebus.service, and web_serve.service. After restarting the computer, you can use the following command to view the service status:

```bash
systemctl --user status demo_serve
systemctl --user status web_serve
systemctl --user messagebus
```
