import os
import json

model_cate = "llm"
cur_dir = os.path.dirname(os.path.abspath(__file__))
root_dir = os.path.dirname(cur_dir)
config_path = os.path.join(root_dir, 'config.json')

with open(config_path, 'r') as f:
    config = json.load(f)

model_name = ''
for item in config[model_cate]:
    if item['enable']:
        model_name = item['model']
        break

if model_name == 'ollama':
    from .ollama_model import LLMModel, llm_model_path
elif model_name == 'genai':
    from .genai_model import LLMModel, llm_model_path
else:
    raise Exception('No implement')