import os
import json
from flask import Flask, render_template, request, jsonify

app = Flask(__name__)
CONFIG_FILE = 'config.json'

def load_config():
    if not os.path.exists(CONFIG_FILE):
        raise Exception('No config file found')
    with open(CONFIG_FILE, 'r') as f:
        return json.load(f)

def save_config(config):
    with open(CONFIG_FILE, 'w') as f:
        json.dump(config, f, indent=4)

@app.route('/')
def index():
    config = load_config()
    return render_template(
        'index.html',
        config=config
    )
@app.route('/save', methods=['POST'])
def save():
    map_data = {
        'asr': request.form.get('asr'),
        'llm': request.form.get('llm'),
        'tts': request.form.get('tts')
    }
    config = load_config()
    for cate in map_data:
        for i in range(len(config[cate])):
            if config[cate][i]['model'] == map_data[cate]:
                config[cate][i]['enable'] = True
            else:
                config[cate][i]['enable'] = False
    save_config(config)
    try:
        os.system('systemctl restart demo_serve.service')
        print("restart demo.py succssfully!")
    except Exception as e:
        print("Failed to restart demo.py serve", e)
    return jsonify(
        {'status': 'success', 'message': 'configuration saved successfully'}
    )

if __name__ == '__main__':
    app.run(debug=True, host='0.0.0.0')
